function [X_TuL,Xstar_TuL,Y_TuL,Z_TuL,Zstar_TuL,Xlocal_TuL,Ylocal_TuL,Zlocal_TuL,...
    SegStar,HShift_local_TuL,TempDef_TuL,ARRAYdate_TuL,Area_TuL,Speed_local_TuL,...
    Acceleration_local_TuL,ErrTunnelLink] = elab2D_TuL(rTuL,accTuL,ay_TuL,ay_TuL_AC,...
    ACCdefRis_TuL,SpeTuL,IDcentralina,DTcatena,DatiElabTunnelLink,NuovoZeroTuL,...
    TempDef_TuL,tolleranzaAcc,Ndevst,Wdevst,NdatiMedia,Ndatidespike,ARRAYdate_TuL,...
    data1_AC,Nodo_AC,margine,ErrTunnelLink,Tmax,Tmin,datainiTuL,FileName)

%% Inizializzazione
fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'elab2D_TuL function started';
fprintf(fileID,fmt,text);

if NuovoZeroTuL == 1
    if NdatiMedia > Ndatidespike
        Ndati = NdatiMedia;
    else
        Ndati = Ndatidespike;
    end
    ini = round(Ndati/2)+1;
    if rem(Ndati,2) == 0
        ini = ini+1;
    end
    clear NDati
    ini = ini + margine;
    if ini < 6
        ini = 6;
    end
    if Ndevst ~= 0 % Allora prendo tutti i dati e solo in seguito considero i nuovi, a valle della funzione filtro
        ini = 1;
    end
    DatiElabTunnelLink = DatiElabTunnelLink(ini:end,:);
    ACCdefRis_TuL = ACCdefRis_TuL(ini:end,:);
    ARRAYdate_TuL = ARRAYdate_TuL(ini:end,1);
    TempDef_TuL = TempDef_TuL(ini:end,:);
    accTuL = accTuL(ini:end,:);
    ErrTunnelLink = ErrTunnelLink(ini:end,:);
end

%% Definizione dei dati
Nnodi = rTuL;
[r,~] = size(accTuL);
[Ndati,~] = size(ARRAYdate_TuL);
ax = zeros(r,Nnodi);
ay = zeros(r,Nnodi);
az = zeros(r,Nnodi);
for i=1:Nnodi
    ax(:,i) = accTuL(:,(i-1)*3+1); % ax
    ay(:,i) = accTuL(:,(i-1)*3+2:(i-1)*3+2); % ay
    az(:,i) = accTuL(:,(i-1)*3+3:(i-1)*3+3); % az
end

ax = ax'; % riga nodi, colonna date
ay = ay'; % riga nodi, colonna date
az = az'; % riga nodi, colonna date
% calcolo orario
asseX_TuL = zeros(Nnodi,Ndati); % Raccoglie i dati locali nella base della sezione della galleria
asseY_TuL = zeros(Nnodi,Ndati); % Raccoglie i dati locali nella direzione trasversale rispetto alla sezione della galleria
asseZ_TuL = zeros(Nnodi,Ndati); % Raccoglie i dati locali nell'altezza della sezione della galleria
% Calcolo antiorario
asseXstar_TuL = zeros(Nnodi,Ndati);
asseYstar_TuL = zeros(Nnodi,Ndati);
asseZstar_TuL = zeros(Nnodi,Ndati);
% Calcolo orario
X_TuL = zeros(Nnodi,Ndati); % Raccoglie i dati cumulati nella base della sezione della galleria
Y_TuL = zeros(Nnodi,Ndati); % Raccoglie i dati cumulati nella direzione trasversale rispetto alla sezione della galleria
Z_TuL = zeros(Nnodi,Ndati); % Raccoglie i dati cumulati nell'altezza della sezione della galleria
% Calcolo antiorario
Xstar_TuL = zeros(Nnodi,Ndati);
Ystar_TuL = zeros(Nnodi,Ndati);
Zstar_TuL = zeros(Nnodi,Ndati);

% attivo/disattivo calcolo stella
[Verso,Segmenti,Peso,PosIniEnd,Punti_Noti,Antiorario] = star(IDcentralina,...
    DTcatena,FileName); % INPUT SITO SPECIFICO DA DARE !!!

% Carico file con nodi da correggere di segno
[indiceX,indiceZ] = segnoTuL(IDcentralina,DTcatena,FileName);

[dim,~] = size(Segmenti); % numero di punti per il calcolo della stella
SegStar = zeros(dim,Ndati);
% parametri per il calcolo
SpeTuL = SpeTuL(2:end,1); % valori di primo tentativo segmenti di pertinenza

% --- Modifica Sito Specifica per Synthesis Ilot Pasteur ---
if strcmp(IDcentralina,'ID0142') == 1
    [dimS,~] = size(SpeTuL);
    for ss = 1:dimS
        SpeTuL(ss) = 0.5;
    end
end

for jj = 1:Ndati
    if jj == 1 % al primo dato raccolto riporto i punti di calcolo sui punti noti
       if NuovoZeroTuL == 0 % calcolo a partire dalla prima data
          [cXo,cYo,cZo,asseX_TuL,asseY_TuL,asseZ_TuL,asseZstar_TuL] = punti_noti_TuL(asseX_TuL,...
              asseY_TuL,asseZ_TuL,Punti_Noti,PosIniEnd);
          cXoStar = [];
          cZoStar = [];
       elseif NuovoZeroTuL == 1 % calcolo a partire da dati già elaborati a cui mi riferisco
              [cXo,cXo_ini,cXoStar,cYo,~,cZo,cZo_ini,cZoStar,asseX_TuL,...
                asseXstar_TuL,asseY_TuL,asseZ_TuL,asseZstar_TuL] = punti_noti_exe_TuL(asseX_TuL,...
                asseY_TuL,asseZ_TuL,DatiElabTunnelLink,PosIniEnd,IDcentralina,DTcatena);
       end
       for ii = 1:Nnodi
           [X_TuL,Y_TuL,Z_TuL,asseX_TuL,asseY_TuL,asseZ_TuL,Xstar_TuL,Ystar_TuL,...
                Zstar_TuL,asseXstar_TuL,asseYstar_TuL,asseZstar_TuL] = CalcoloBiax_TuL(SpeTuL,...
                ii,jj,ax,ay,az,asseX_TuL,asseY_TuL,asseZ_TuL,X_TuL,Y_TuL,Z_TuL,...
                asseXstar_TuL,asseYstar_TuL,asseZstar_TuL,Xstar_TuL,Ystar_TuL,Zstar_TuL,...
                Nnodi,PosIniEnd,indiceX,indiceZ,rTuL,FileName);
       end 
       [shiftX,shiftY,shiftZ,shiftXstar,shiftYstar,shiftZstar] = pos_ini_TuL(cXo,...
            cXoStar,cYo,cZo,cZoStar,X_TuL,Y_TuL,Z_TuL,Xstar_TuL,Ystar_TuL,Zstar_TuL,NuovoZeroTuL);
    else
        for ii = 1:Nnodi
            [X_TuL,Y_TuL,Z_TuL,asseX_TuL,asseY_TuL,asseZ_TuL,Xstar_TuL,Ystar_TuL,...
                Zstar_TuL,asseXstar_TuL,asseYstar_TuL,asseZstar_TuL] = CalcoloBiax_TuL(SpeTuL,...
                ii,jj,ax,ay,az,asseX_TuL,asseY_TuL,asseZ_TuL,X_TuL,Y_TuL,Z_TuL,...
                asseXstar_TuL,asseYstar_TuL,asseZstar_TuL,Xstar_TuL,Ystar_TuL,...
                Zstar_TuL,Nnodi,PosIniEnd,indiceX,indiceZ,rTuL,FileName);
        end
    end
    %      riporto X, Y e Z sui punti noti
    X_TuL(:,jj) = X_TuL(:,jj) - shiftX(:,1);
    Y_TuL(:,jj) = Y_TuL(:,jj) - shiftY(:,1);
    Z_TuL(:,jj) = Z_TuL(:,jj) - shiftZ(:,1);
    Xstar_TuL(:,jj) = Xstar_TuL(:,jj) - shiftXstar(:,1);
    Ystar_TuL(:,jj) = Ystar_TuL(:,jj) - shiftYstar(:,1);
    Zstar_TuL(:,jj) = Zstar_TuL(:,jj) - shiftZstar(:,1);
    % Nel calcolo della stella non considero Y
    [SegStar] = CalcoloStar(X_TuL,Z_TuL,Xstar_TuL,Zstar_TuL,Verso,Segmenti,Peso,jj,SegStar,Nnodi,dim);
end

Xrif = X_TuL; % mi serve dopo
Yrif = Y_TuL; % mi serve dopo
Zrif = Z_TuL; % mi serve dopo
Xstar_rif = Xstar_TuL; % mi serve dopo
Ystar_rif = Ystar_TuL; % mi serve dopo
Zstar_rif = Zstar_TuL; % mi serve dopo

dX = diff(asseX_TuL,1,2);
dY = diff(asseY_TuL,1,2);
dZ = diff(asseZ_TuL,1,2);
dXstar = diff(asseXstar_TuL,1,2);
dYstar = diff(asseYstar_TuL,1,2);
dZstar = diff(asseZstar_TuL,1,2);

%% Controllo della risultante delle accelerazioni
clear r
clear rr
clear c
clear cc
ACCdefRis_TuL = ACCdefRis_TuL';  % Nodi in riga, date in colonna
[r,c] = size(ACCdefRis_TuL);
[rr,cc] = size(X_TuL);

% controllo che le matrici con le risultanti delle accelerazioni e 
% le matrici con i dati di spostamento abbiano le stesse dimensioni
if r~=rr
    text = '---Warning! Number of row of displacement data do not correspond to the number of acceleration cosine vector!---';
    fprintf(fileID,fmt,text);
end
if c~=cc
    text = '---Warning! Number of column of displacement data do not correspond to the number of acceleration cosine vector!---';
    fprintf(fileID,fmt,text);
end
fileID = fopen(FileName,'a');
fmt = '%s \r';
fprintf(fileID,fmt,text);
clear i
clear j
cont = 1; % contatore
cont2 = 1; % contatore
cont3 = 1; % contatore
TempDef_TuL = TempDef_TuL';
text1 = 'There are not correction of Tunnel Link based on acceleration vector filter';
text2 = 'There are not correction of Tunnel Link based on uncalibrated Acceleration vector';
text3 = 'There are not correction of Tunnel Link based on temperature filter';
LIMinf = 0.9;
LIMsup = 1.1;
for j = 2:c % data
    for i = 1:r % nodo
        % se il valore assoluto della differenza è maggiore della
        % tolleranza, pongo gli spostamenti giornalieri pari a 0
        if abs(ACCdefRis_TuL(i,j)-ACCdefRis_TuL(i,j-1)) > tolleranzaAcc 
            dX(i,j-1) = 0;
            dY(i,j-1) = 0;
            dZ(i,j-1) = 0;
            dXstar(Nnodi+1-i,j-1) = 0;
            dYstar(Nnodi+1-i,j-1) = 0;
            dZstar(Nnodi+1-i,j-1) = 0;
            text1 = ['' num2str(cont) ' correction executed for Tunnel Link - Acceleration vector filter!'];
            cont = cont+1;
        end
        if ACCdefRis_TuL(i,j) < LIMinf || ACCdefRis_TuL(i,j) > LIMsup % Il nodo è fuori taratura!
            dX(i,j-1) = 0;
            dY(i,j-1) = 0;
            dZ(i,j-1) = 0;
            dXstar(Nnodi+1-i,j-1) = 0;
            dYstar(Nnodi+1-i,j-1) = 0;
            dZstar(Nnodi+1-i,j-1) = 0;
            TempDef_TuL(i,j) = TempDef_TuL(i,j-1);
            text2 = ['' num2str(cont) ' correction executed for Tunnel link - uncalibrated Acceleration vector!'];
            cont3 = cont3+1;
        end
    end
end

FileTemperature = ['' IDcentralina '-' DTcatena '-TuL-Therm.csv'];
if isfile(FileTemperature) == 1
    DatiRaw = csvread(FileTemperature);
    [rDR,cDR] = size(DatiRaw);
    DatiRaw(:,1) = DatiRaw(:,1) + 730000;
else
    rDR = 1;
    cDR = 1;
end
for b = 1:c % Data
    for a = 1:r % Nodo
        % NON considero i dati al di sopra dei 80 °C o al di sotto dei -30 °C! 
        if TempDef_TuL(a,b) > Tmax || TempDef_TuL(a,b) < Tmin
            cont2 = cont2+1;
            if b == 1
                if isfile(FileTemperature) == 1
                    RawDate = find(DatiRaw(:,1)<=datenum(datainiTuL));
                    if isempty(RawDate) == 1
                        cc = 2;
                        while cc <= c
                            if TempDef_TuL(a,cc) > Tmax || TempDef_TuL(a,cc) < Tmin
                                cc = cc+1;
                            else
                                break
                            end
                        end
                        TempDef_TuL(a,b) = TempDef_TuL(a,cc);
                    else
                        if isnan(DatiRaw(RawDate(end),a+1)) == 0
                            TempDef_TuL(a,b) = DatiRaw(RawDate(end),a+1);
                            ErrTunnelLink(b,a) = 0.5;
                            wardat = 'Temperature data of Tunnel Link nodes corrected using Raw Data of reference Csv file.';
                            fprintf(fileID,fmt,wardat);
                        else
                            cc = 2;
                            while cc <= c
                                if TempDef_TuL(a,cc) > Tmax || TempDef_TuL(a,cc) < Tmin
                                    cc = cc+1;
                                else
                                    break
                                end
                            end
                            TempDef_TuL(a,b) = TempDef_TuL(a,cc);
                        end
                    end
                else
                    cc = 2;
                    while cc <= c
                        if TempDef_TuL(a,cc) > Tmax || TempDef_TuL(a,cc) < Tmin
                            cc = cc+1;
                        else
                            break
                        end
                    end
                    TempDef_TuL(a,b) = TempDef_TuL(a,cc);
                end
            else
                TempDef_TuL(a,b) = TempDef_TuL(a,b-1);
                dX(a,b-1) = 0;
                dY(a,b-1) = 0;
                dZ(a,b-1) = 0;
                ErrTunnelLink(b,a) = 0.5;
            end
            text3 = ['' num2str(cont2) ' correction executed for Tunnel Link - Temperature filter!'];
        end
    end
end

if  rDR~=1 && cDR~=1 && isempty(DatiRaw) == 0
    RawDate1 = find(DatiRaw(:,1)<=ARRAYdate_TuL(1));
    if isempty(RawDate1) == 1
        RawDate2 = 1;
    elseif RawDate1(end) == rDR
        RawDate2 = find(ARRAYdate_TuL(:,1)>DatiRaw(end,1));
    else
        RawDate2 = find(ARRAYdate_TuL(:,1)>DatiRaw(RawDate1(end)+1,1));
    end
else
    RawDate1 = [];
    RawDate2 = 1;
end
if isempty(RawDate1) == 0 && isempty(RawDate2) == 0
    Dati = [DatiRaw(1:RawDate1(end),:); ARRAYdate_TuL(RawDate2(1):end) TempDef_TuL(:,RawDate2(1):end)'];
elseif isempty(RawDate1) == 1 && isempty(RawDate2) == 0
    Dati = [ARRAYdate_TuL TempDef_TuL'];
else
    Dati = DatiRaw;
end
% Elimino appoggio più vecchio di un mese
RawDate3 = find(Dati(:,1)<now-30);
if isempty(RawDate3) == 0
    [rDati,~] = size(Dati);
    if RawDate3(end) == rDati
    else
        Dati = Dati(RawDate3(end)+1:end,:);
    end
end
if isfile(FileTemperature) == 1
    delete(FileTemperature);
end
Dati(:,1) = Dati(:,1) - 730000;
csvwrite(FileTemperature,Dati);

TempDef_TuL = TempDef_TuL';
fprintf(fileID,fmt,text1);
fprintf(fileID,fmt,text2);
fprintf(fileID,fmt,text3);

fprintf(fileID,fmt,'filtro_TuL function launched');

%% Filtro
[dX,dY,dZ,dXstar,dYstar,dZstar,text4] = filtro_TuL(dX,dY,dZ,dXstar,...
    dYstar,dZstar,Ndevst,Wdevst);

fprintf(fileID,fmt,'filtro_TuL function closed');

fprintf(fileID,fmt,text4);
if NuovoZeroTuL == 1 && Ndevst ~= 0
    if NdatiMedia > Ndatidespike
        NdatiF = NdatiMedia;
    else
        NdatiF = Ndatidespike;
    end
    ini = round(NdatiF/2)+1;
    if rem(NdatiF,2) == 0
        ini = ini+1;
    end
    clear NDatiF
    iniST = round(Wdevst/2);
    if rem(Wdevst,2) == 0
        iniST = iniST+1;
    end
    iniST = iniST + margine;
    if iniST > ini
        ini = iniST;
    end
    if ini < 6
        ini = 6;
    end
    dX = dX(:,ini:end);
    dY = dY(:,ini:end);
    dZ = dZ(:,ini:end);
    dXstar = dXstar(:,ini:end);
    dYstar = dYstar(:,ini:end);
    dZstar = dZstar(:,ini:end);
    TempDef_TuL = TempDef_TuL(ini:end,:);
    DatiElabTunnelLink = DatiElabTunnelLink(ini:end,:);
    ARRAYdate_TuL = ARRAYdate_TuL(ini:end,1); 
    ErrTunnelLink = ErrTunnelLink(ini:end,:);
end

% Controllo che l'arco rovescio debba già essere calcolato o meno
data_TuL = ARRAYdate_TuL;
data_ARC = datenum(data1_AC);
Delta = data_ARC-data_TuL;
Check = find(Delta>0);
Control_ARC = isempty(Check);
if Control_ARC == 0
    indice_ARC = [];
    ay_AC = ay_TuL_AC';
else
    Inizio = find(Delta<=0);
    indice_ARC = Inizio(1);
    if NuovoZeroTuL == 1
        ay_AC = ay_TuL_AC';
    else
        ay_AC = ay;
    end
end
    

%% Finalizzo i calcoli
[rx,cx] = size(dX);
% totale del singolo nodo data per data
sommaX = zeros(rx,cx+1);
sommaXstar = zeros(rx,cx+1);
sommaY = zeros(rx,cx+1);
sommaYstar = zeros(rx,cx+1);
sommaZ = zeros(rx,cx+1);
sommaZstar = zeros(rx,cx+1);
% cumulata del singolo nodo data per data in posizione assoluta
% il primo valore è quello di posizione assoluta iniziale
X_TuL = zeros(rx,cx+1);
Y_TuL = zeros(rx,cx+1);
Z_TuL = zeros(rx,cx+1);
Xstar_TuL = zeros(rx,cx+1);
Ystar_TuL = zeros(rx,cx+1);
Zstar_TuL = zeros(rx,cx+1);
% cumulata del singolo nodo data per data in posizione relativa
% il primo valore è quello di posizione assoluta iniziale
Xlocal_TuL = zeros(Nnodi,Ndati);
Ylocal_TuL = zeros(Nnodi,Ndati);
Zlocal_TuL = zeros(Nnodi,Ndati);
Xlocal_star = zeros(Nnodi,Ndati);
Ylocal_star = zeros(Nnodi,Ndati);
Zlocal_star = zeros(Nnodi,Ndati);
ris_local = zeros(Nnodi,1);
Speed_local_TuL = zeros(Nnodi,Ndati);
Acceleration_local_TuL = zeros(Nnodi,Ndati);
% Calcolo area della sezione
Area_TuL = zeros(1,Ndati);
AreaStar_TuL = zeros(1,Ndati);

% Primo dato
X_TuL(:,1) = Xrif(:,1);
Y_TuL(:,1) = Yrif(:,1);
Z_TuL(:,1) = Zrif(:,1);
Area_TuL(:,1) = polyarea(X_TuL(:,1),Z_TuL(:,1));
AreaStar_TuL(:,1) = polyarea(Xstar_TuL(:,1),Zstar_TuL(:,1));
Xstar_TuL(:,1) = Xstar_rif(:,1);
Ystar_TuL(:,1) = Ystar_rif(:,1);
Zstar_TuL(:,1) = Zstar_rif(:,1);
if Control_ARC == 0 % l'arco rovescio si calcola da dopo
    X_TuL(Nodo_AC:end,1) = Punti_Noti(Nodo_AC+1:end,1);
    Y_TuL(Nodo_AC:end,1) = Punti_Noti(Nodo_AC+1:end,2);
    Z_TuL(Nodo_AC:end,1) = Punti_Noti(Nodo_AC+1:end,3);
    Xstar_TuL(1:rTuL-Nodo_AC+1,1) = Punti_Noti(Nodo_AC+1:end,1);
    Ystar_TuL(1:rTuL-Nodo_AC+1,1) = Punti_Noti(Nodo_AC+1:end,2);
    Zstar_TuL(1:rTuL-Nodo_AC+1,1) = Punti_Noti(Nodo_AC+1:end,3);
end
HShift_local_TuL = zeros(rx,cx+1);
    
if NuovoZeroTuL == 1
    [~,cE] = size(DatiElabTunnelLink);
    cont = 3;
    contS = 11;
    n = 1;
    while cont<=cE
        sommaX(n,1) = cell2mat(DatiElabTunnelLink(1,cont))';
        Xlocal_TuL(n,1) = sommaX(n,1);
        sommaY(n,1) = cell2mat(DatiElabTunnelLink(1,cont+1))';
        Ylocal_TuL(n,1) = sommaY(n,1);
        sommaZ(n,1) = cell2mat(DatiElabTunnelLink(1,cont+2))';
        Zlocal_TuL(n,1) = sommaZ(n,1);
        if n < rTuL
            if n == 1 % primo
                sommaXstar(n,1) = Xstar_TuL(n,1)-cXo_ini(end-n,1);
                sommaZstar(n,1) = Zstar_TuL(n,1)-cZo_ini(end-n,1);
            else
                sommaXstar(n,1) = (Xstar_TuL(n,1)-Xstar_TuL(n-1,1))-(cXo_ini(end-n,1)-cXo_ini(end-n+1,1));
                sommaZstar(n,1) = (Zstar_TuL(n,1)-Zstar_TuL(n-1,1))-(cZo_ini(end-n,1)-cZo_ini(end-n+1,1));
            end
        else % ultimo
            sommaXstar(n,1) = (Xstar_TuL(n,1)-Xstar_TuL(end-1,1))-(cXo_ini(end,1)-cXo_ini(1,1));
            sommaZstar(n,1) = (Zstar_TuL(n,1)-Zstar_TuL(end-1,1))-(cZo_ini(end,1)-cZo_ini(1,1));
        end
        sommaYstar(n,1) = cell2mat(DatiElabTunnelLink(1,cE-contS+2))';
        ris_local(n,1) = cell2mat(DatiElabTunnelLink(1,cont+9))';
        Speed_local_TuL(n,1) = cell2mat(DatiElabTunnelLink(1,cont+12))';
        Acceleration_local_TuL(n,1) = cell2mat(DatiElabTunnelLink(1,cont+13))';
        cont=cont+16;
        contS=contS+16;
        n = n+1;
    end
    Xlocal_star(:,1) = sommaXstar(:,1);
    Zlocal_star(:,1) = sommaZstar(:,1);
end

for iii = 1:cx % date
    % somma singoli spostamenti del singolo nodo
    sommaX(1:Nodo_AC-1,iii+1) = sum(dX(1:Nodo_AC-1,1:iii),2)+sommaX(1:Nodo_AC-1,1);
    sommaY(1:Nodo_AC-1,iii+1) = sum(dY(1:Nodo_AC-1,1:iii),2)+sommaY(1:Nodo_AC-1,1);
    sommaZ(1:Nodo_AC-1,iii+1) = sum(dZ(1:Nodo_AC-1,1:iii),2)+sommaZ(1:Nodo_AC-1,1);
    sommaXstar(rTuL-Nodo_AC+2:end,iii+1) = sum(dXstar(rTuL-Nodo_AC+2:end,1:iii),2)+sommaXstar(rTuL-Nodo_AC+2:end,1);
    sommaYstar(rTuL-Nodo_AC+2:end,iii+1) = sum(dYstar(rTuL-Nodo_AC+2:end,1:iii),2)+sommaYstar(rTuL-Nodo_AC+2:end,1);
    sommaZstar(rTuL-Nodo_AC+2:end,iii+1) = sum(dZstar(rTuL-Nodo_AC+2:end,1:iii),2)+sommaZstar(rTuL-Nodo_AC+2:end,1);
    if Control_ARC == 0 % l'arco rovescio si calcola da dopo
        sommaX(Nodo_AC:end,iii+1) = 0;
        sommaY(Nodo_AC:end,iii+1) = 0;
        sommaZ(Nodo_AC:end,iii+1) = 0;
        sommaXstar(1:rTuL-Nodo_AC+1,iii+1) = 0;
        sommaYstar(1:rTuL-Nodo_AC+1,iii+1) = 0;
        sommaZstar(1:rTuL-Nodo_AC+1,iii+1) = 0;
    else
        sommaX(Nodo_AC:end,iii+1) = sum(dX(Nodo_AC:end,indice_ARC:iii),2)+sommaX(Nodo_AC:end,1);
        sommaY(Nodo_AC:end,iii+1) = sum(dY(Nodo_AC:end,indice_ARC:iii),2)+sommaY(Nodo_AC:end,1);
        sommaZ(Nodo_AC:end,iii+1) = sum(dZ(Nodo_AC:end,indice_ARC:iii),2)+sommaZ(Nodo_AC:end,1);
        sommaXstar(1:rTuL-Nodo_AC+1,iii+1) = sum(dXstar(1:rTuL-Nodo_AC+1,indice_ARC:iii),2)+sommaXstar(1:rTuL-Nodo_AC+1,1);
        sommaYstar(1:rTuL-Nodo_AC+1,iii+1) = sum(dYstar(1:rTuL-Nodo_AC+1,indice_ARC:iii),2)+sommaYstar(1:rTuL-Nodo_AC+1,1);
        sommaZstar(1:rTuL-Nodo_AC+1,iii+1) = sum(dZstar(1:rTuL-Nodo_AC+1,indice_ARC:iii),2)+sommaZstar(1:rTuL-Nodo_AC+1,1);
    end
    
    % spostamenti locali riferiti alla posizione assoluta
    Xlocal_TuL(:,iii+1) = sommaX(:,iii+1);
    Ylocal_TuL(:,iii+1) = sommaY(:,iii+1);
    Zlocal_TuL(:,iii+1) = sommaZ(:,iii+1);
    Xlocal_star(:,iii+1) = sommaXstar(:,iii+1);
    Ylocal_star(:,iii+1) = sommaYstar(:,iii+1);
    Zlocal_star(:,iii+1) = sommaZstar(:,iii+1);
    
    % cumulata spostamenti (posizione assoluta)
    if NuovoZeroTuL == 0
        X_TuL(:,iii+1) = Xrif(:,1) + cumsum(sommaX(:,iii+1));
        Y_TuL(:,iii+1) = Yrif(:,1) + cumsum(sommaY(:,iii+1));
        Z_TuL(:,iii+1) = Zrif(:,1) + cumsum(sommaZ(:,iii+1));
        Xstar_TuL(:,iii+1) = Xstar_rif(:,1) + cumsum(sommaXstar(:,iii+1));
        Ystar_TuL(:,iii+1) = Ystar_rif(:,1) + cumsum(sommaYstar(:,iii+1));
        Zstar_TuL(:,iii+1) = Zstar_rif(:,1) + cumsum(sommaZstar(:,iii+1));
    elseif NuovoZeroTuL == 1
            X_TuL(:,iii+1) = Xrif(:,1) + cumsum(sommaX(:,iii+1)) - cumsum(sommaX(:,1));
            Y_TuL(:,iii+1) = Yrif(:,1) + cumsum(sommaY(:,iii+1)) - cumsum(sommaY(:,1));
            Z_TuL(:,iii+1) = Zrif(:,1) + cumsum(sommaZ(:,iii+1)) - cumsum(sommaZ(:,1));
            Xstar_TuL(:,iii+1) = Xstar_rif(:,1) + cumsum(sommaXstar(:,iii+1)) - cumsum(sommaXstar(:,1));
            Ystar_TuL(:,iii+1) = Ystar_rif(:,1) + cumsum(sommaYstar(:,iii+1)) - cumsum(sommaYstar(:,1));
            Zstar_TuL(:,iii+1) = Zstar_rif(:,1) + cumsum(sommaZstar(:,iii+1)) - cumsum(sommaZstar(:,1));
    end
    
    Area_TuL(1,iii+1) = polyarea(X_TuL(:,iii+1),Z_TuL(:,iii+1));
    AreaStar_TuL(1,iii+1) = polyarea(Xstar_TuL(:,iii+1),Zstar_TuL(:,iii+1));
    % Segno + per spostamenti verso il centro, segno - per spostamenti
    % verso l'esterno
    if NuovoZeroTuL == 1
        HShift_local_TuL(:,1) = ris_local;
    end
    HShift_local_TuL(:,iii+1) = (sommaX(:,iii+1).^2+sommaZ(:,iii+1).^2).^0.5;
    
    if NuovoZeroTuL == 1
        ay_rif = ay_TuL';
        ay_rif_AC = ay_AC;
    else
        ay_rif = ay;
        ay_rif_AC = ay;
    end
    for jjj = 1:Nnodi
        Quadrante = Antiorario(jjj,1);
        if jjj >= Nodo_AC
            AY_RIF = ay_rif_AC;
        else
            AY_RIF = ay_rif;
        end
        if Quadrante == 1
            if ay(jjj,iii+1) - AY_RIF(jjj,1) < 0 % rotazione antioraria, moltiplico per -1 (va in fuori)
                HShift_local_TuL(jjj,iii+1) = HShift_local_TuL(jjj,iii+1).*(-1);
            end
        elseif Quadrante == 2
            if ay(jjj,iii+1) - AY_RIF(jjj,1) > 0 % rotazione antioraria, moltiplico per -1 (va in fuori)
                HShift_local_TuL(jjj,iii+1) = HShift_local_TuL(jjj,iii+1).*(-1);
            end
        elseif Quadrante == 3
            if ay(jjj,iii+1) - AY_RIF(jjj,1) > 0 % rotazione antioraria, moltiplico per -1 (va in fuori)
                HShift_local_TuL(jjj,iii+1) = HShift_local_TuL(jjj,iii+1).*(-1);
            end
        elseif Quadrante == 4
            if ay(jjj,iii+1) - AY_RIF(jjj,1) < 0 % rotazione antioraria, moltiplico per -1 (va in fuori)
                HShift_local_TuL(jjj,iii+1) = HShift_local_TuL(jjj,iii+1).*(-1);
            end
        end
    end
    jj = iii+1; % contatore date
    [SegStar] = CalcoloStar(X_TuL,Z_TuL,Xstar_TuL,Zstar_TuL,Verso,Segmenti,Peso,jj,SegStar,Nnodi,dim);
end

%% Calcolo velocità e accelerazione di spostamento giornaliera
[numDate,~] = size(ARRAYdate_TuL); % numero di date
d = 1;
p = 1;
diffDate = 0;
n = 1;
period = 1; % calcolo giornaliero
ContSUP = [];
for dd = 1:numDate
    while diffDate < period
          d = d+1;  
          if d > numDate % Se d supera le date disponibili, esco dal ciclo while
              break
          end
          diffDate = ARRAYdate_TuL(d) - ARRAYdate_TuL(p);
    end
    if d >numDate
        break
    end
    ContSUP(n,1) = d; % Creo matrice indici dell'estremo superiore della differenza
    ContINF(n,1) = p; % Creo matrice indici dell'estremo inferiore della differenza
    p = p+1; % passo alla data di partenza successiva 
    d = p; % resetto il conto di d
    n = n+1;
    diffDate = 0;
end

check = isempty(ContSUP);
if check == 0
    [nDate,~] = size(ContSUP);
    for s = 1:rTuL
        N = 1;
        for dd = 1:nDate
            Speed_local_TuL(s,ContSUP(N,1)) = HShift_local_TuL(s,ContSUP(N,1)) - HShift_local_TuL(s,ContINF(N,1));
            Acceleration_local_TuL(s,ContSUP(N,1)) = Speed_local_TuL(s,ContSUP(N,1)) - Speed_local_TuL(s,ContINF(N,1));
            N = N+1;
        end
    end
end

fclose(fileID);

%% Approssimazioni
[X_TuL,Y_TuL,Z_TuL,Xlocal_TuL,Ylocal_TuL,Zlocal_TuL,Xstar_TuL,Zstar_TuL,HShift_local_TuL,...
    SegStar,TempDef_TuL,Speed_local_TuL,Acceleration_local_TuL,Area_TuL] = approx_TuL(X_TuL,...
    Y_TuL,Z_TuL,Xlocal_TuL,Ylocal_TuL,Zlocal_TuL,Xstar_TuL,Zstar_TuL,HShift_local_TuL,...
    SegStar,TempDef_TuL,Speed_local_TuL,Acceleration_local_TuL,Area_TuL,FileName);

[r,~] = size(ErrTunnelLink);
Matrice_err = zeros(r,rTuL);
for i = 1:r % date
    d = 1;
    for n = 1:rTuL % nodi
        j = 1;
        err = ErrTunnelLink(i,d:d+3);
        while j <= 4
            if err(1,j) == 1
                Matrice_err(i,n) = 1;
            end
            j = j+1;
        end
        d = d+4;
    end
end
ErrTunnelLink = Matrice_err';
    
fileID = fopen(FileName,'a');
fmt = '%s \r';
text4 = 'Tunnel Link calculation executed correctly, elab2D_TuL function closed';
fprintf(fileID,fmt,text4);
fclose(fileID);

end